/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#include <papyrus/papyrus-config.h>

#ifndef PAPYRUSSMARTPOINTER
#define PAPYRUSSMARTPOINTER
  // Headers for smart pointers
  #ifdef PAPYRUS_USE_BOOST_SMART_POINTER
    #include <boost/shared_ptr.hpp>
    #define PapyrusSmartPointer boost::shared_ptr
    #define papyrus_smart_pointer_cast boost::dynamic_pointer_cast
  #else
    #include <typeinfo>
    #include <memory>
    #include <functional>
    #include <bits/concurrence.h>
    #include <ext/mt_allocator.h>
    #include <tr1/boost_shared_ptr.h>
    #define PapyrusSmartPointer std::tr1::shared_ptr
    #define papyrus_smart_pointer_cast std::tr1::dynamic_pointer_cast
  #endif
#endif
